<?php
/*=================================================================
#	Copyright (c) 2002 by [ x-dev.de/x-gfx.de ]
#	Guestbook-Script by Robert Klikics [rob@x-dev.de]
#==================================================================
#	Website: 	http://www.x-gfx.de [english/german]      
#	Requires:	PHP 4.1.x ++
#	License: 	GPL/Free
#	[ Comments/Additions are welcome! ]
#==================================================================
#	Help: Please read the doc-files for further informations!
#==================================================================
#	File: class.admin.php [admin-class]
#===================================================================*/ 

class admin {
	
	var $xgb;	// xgb-obj.
	
	
	/* constructor */
	function admin() {
		
		$this->xgb = new xGB;	// create xgb-obj.
		
		@session_start("xgb");
		
		// what to do? ;)
		if( empty($_GET['do']) )	$do = $_POST['do'];
		else				$do = $_GET['do'];
		
		switch($do) {
			
			default:
				if($this->check())	echo $this->menu();
				else			echo $this->logon();
				break;
			case login:
				echo $this->check_login_data();
				break;
			case logout:
				session_unset();
				session_destroy();
				echo "Thanks, logged out --> <a href='".$_SERVER[PHP_SELF]."?s=0'>Main Page</a>\n";
				exit;
			case edit_del:
				echo $this->xgb->get_posts();
				break;
			case del:
				if( csv::delete($_GET['id']) )	echo "Thanks, message deleted  --> <a href='".$_SERVER[PHP_SELF]."?act=admin'>Main Page</a>\n";
				else				echo "Sorry, could not delete message ...";
				break;
			case edit:
				echo $this->edit_form($_GET['id']);
				break;
			case edit_msg:
				if( csv::save_edited_msg($_POST['id']) )	echo "Thanks, message edited  --> <a href='".$_SERVER[PHP_SELF]."?act=admin'>Main Page</a>\n";
				else						echo "Sorry, could not edit message ...";
				break;
			case badwords:
				echo $this->badwords();
				break;
			case save_badwords:
				if( csv::save_badwords() )	echo "Thanks, badwords saved  --> <a href='".$_SERVER[PHP_SELF]."?act=admin'>Main Page</a>\n";
				else				echo "Sorry, could not save badwords ...";
				break;
			case smilies:
				echo $this->smilies();
				break;
			case new_smilie:
				if( csv::add_smilie() )		echo "Thanks, new smilie saved  --> <a href='".$_SERVER[PHP_SELF]."?act=admin'>Main Page</a>\n";
				else				echo "Sorry, could not save smilie ...";
				break;
			case delete_smilie:
				if( csv::del_smilie() )		echo "Thanks, new smilie deleted --> <a href='".$_SERVER[PHP_SELF]."?act=admin'>Main Page</a>\n";
				else				echo "Sorry, could not delete smilie ...";
				break;
			}
	}
	
	/* logged on? */
	function check() {
	
		global $cfg;
		
		if( $_SESSION['xgb_pass'] == $cfg['admin_pass'])	return true;
		else							return false;		
		
	}
	
	/* login-form */
	function logon() {
		
		return <<<EOF
		Admin-Login:<p>
		<form action='$_SERVER[PHP_SELF]' method='post'>
			<input type='hidden' name='act' value='admin'>
			<input type='hidden' name='do' value='login'>
			<input type='password' name='pass'><p> 
			<input type='submit' id='button' value='  Login  '>
		</form>
		<p>
		<font color='red'>!!! Please note that cookies are required here !!!</font>
		<p>
		[ <a href='$_SERVER[PHP_SELF]' title='back'>back</a> ]
EOF;
		
	}
	
	/* validate login */
	function check_login_data() {
		
		global $cfg;
		
		if($_POST['pass'] == $cfg['admin_pass']) {
			
			// start sess.
			$_SESSION['xgb_pass'] = $_POST['pass'];
			echo $this->menu();
			
		} else {
			
			return $this->logon();
		}
	}
	
	/* admin-menu */
	function menu() {
	
		return <<<EOF
		<h3>xGB 2.0 Admin-Menu</h3>
		<p>[ 
		<a href='$_SERVER[PHP_SELF]?act=admin&do=edit_del&s=0' title='Edit/Delete Messages'>Edit/Delete Messages</a> | 
		<a href='$_SERVER[PHP_SELF]?act=admin&do=badwords' title='Edit Badwords'>Edit Badwords</a> | 
		<a href='$_SERVER[PHP_SELF]?act=admin&do=smilies' title='Edit Smilies'>Edit Smilies</a> |
		<a href='http://www.x-gfx.de' title='visit x-gfx.de for updates' target='_blank'>visit x-gfx.de</a> ]
		<p>
		[ <a href='$_SERVER[PHP_SELF]?act=admin&do=logout' title='Admin-Logout'>Logout</a> ] :: [ <a href='$_SERVER[PHP_SELF]'>Main</a> ]
EOF;
		
	}
	
	/* edit-form */
	function edit_form($id) {
		
		// get line
		foreach( file("csv/posts.txt") as $line) {
			
			if( preg_match("/^".$_GET['id']."/i", $line) )	{ $data = explode("",$line); break; }
			
		}
		
		// replace <br /> with \n
		$data['4'] = preg_replace("/<br \/>/i", "\n", $data['4']);
		
	 	return <<<EOF
		<form action='$_SERVER[PHP_SELF]' method='post'>
			<input type='hidden' name='act' value='admin'>
			<input type='hidden' name='do'  value='edit_msg'>
			<input type='hidden' name='id'  value='$_GET[id]'>
			Name:<br>
			<input type='text' name='name' value='$data[2]'  id='sign_input'><br><br>
			E-Mail:<br>
			<input type='text' name='mail' value='$data[1]' id='sign_input'><br><br>
			Homepage:<br>
			<input type='text' value='$data[3]' name='page' maxlength='100' id='sign_input'><br><br>
			Message:<br>
			<textarea id='sign_textarea' name='post'>$data[4]</textarea><br>
			<br>
			<input title='Submit' type='submit' value='  Edit  ' id='button'>
			<input title='Back' type='button' id='button' value='  Back  ' onClick='javasctipt:history.back()'>
		</form>
EOF;
	}
	
	/* show off the badwords */
	function badwords() {
	
		// get them
		$fp = fopen("csv/badwords.txt","r");	
		$bw = fread($fp, filesize("csv/badwords.txt") );
		fclose($fp);
		clearstatcache();
		
		return <<<EOF
		<b>Enter badwords seperatated with , !</b><br>
		Example: Bullshit,Ass,Shit,Damn
		<p>
		<form action='$_SERVER[PHP_SELF]' method='post'>
		<input type='hidden' name='act' value='admin'>
		<input type='hidden' name='do'  value='save_badwords'>
		<textarea name='badwords' cols='50' rows='3' style='border:1px solid black;font:12px verdana'>$bw</textarea>	
		<p>
		<input type='submit' value='Save Badwords' id='button'>
		&nbsp;
		<input type='button' value=' Back ' onClick='javascript:history.back()' id='button'>
		</form>
EOF;
	}
	
	/* show smilies & form to add a new one */
	function smilies() {
		
		$main  = new xGB;
		
		$html  = "<b>Add a new Smile:</b><br>The image must be uploaded to the 'img' folder!<p>\n";
		$html .= "<form action='".$_SERVER['PHP_SELF']."' method='post'>\n";
		$html .= "<input type='hidden' name='act' value='admin'>\n";
		$html .= "<input type='hidden' name='do'  value='new_smilie'>\n";
		$html .= "<input type='text' value='image_name.gif' name='img' onFocus='this.value=\"\"'>\n";
		$html .= "&nbsp;<input type='text' name='code' value='smilie-code' onFocus='this.value=\"\"'>\n<p>\n";
		$html .= "<input type='submit' value='Add Smilie' id='button'>&nbsp;<input type='button' value=' Back ' onClick='javascript:history.back()' id='button'>";
		$html .= "</form>\n<hr style='width:500'>\n<b>Available Smilies:</b><p>\n";
		$html .= "<div style='width:300'>".$main->show_smilies(true)."</div>\n";
		
		return $html;
	}
	
}

?>